__gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc > Class Template Reference

`#include <left_child_next_sibling_heap_.hpp>`

Inherits Cmp_Fn.

## Public Types

typedef _Alloc | allocator_type
typedef Cmp_Fn | cmp_fn
typedef left_child_next_sibling_heap_const_iterator_< node, _Alloc > | const_iterator
typedef __rebind_v::other::const_pointer | const_pointer
typedef __rebind_v::other::const_reference | const_reference
typedef _Alloc::difference_type | difference_type
typedef const_iterator | iterator
typedef left_child_next_sibling_heap_node_point_const_iterator_< node, _Alloc > | point_const_iterator
typedef point_const_iterator | point_iterator
typedef __rebind_v::other::pointer | pointer
typedef __rebind_v::other::reference | reference
typedef _Alloc::size_type | size_type
typedef Value_Type | value_type

## Public Member Functions

| left_child_next_sibling_heap (const Cmp_Fn &)
| left_child_next_sibling_heap (const left_child_next_sibling_heap &)
iterator | begin ()
const_iterator | begin () const
void | clear ()
_GLIBCXX_NODISCARD bool | empty () const
iterator | end ()
const_iterator | end () const
Cmp_Fn & | get_cmp_fn ()
const Cmp_Fn & | get_cmp_fn () const
size_type | max_size () const
size_type | size () const
void | swap (left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc > &)

## Protected Types

typedef node_allocator::value_type | node
typedef _Alloc::template rebind< left_child_next_sibling_heap_node_< Value_Type, Node_Metadata, _Alloc > >::other | node_allocator
typedef node_allocator::const_pointer | node_const_pointer
typedef Node_Metadata | node_metadata
typedef node_allocator::pointer | node_pointer
typedef std::pair< node_pointer, node_pointer > | node_pointer_pair

## Protected Member Functions

void | actual_erase_node (node_pointer)
void | bubble_to_top (node_pointer)
void | clear_imp (node_pointer)
node_pointer | get_new_node_for_insert (const_reference)
template<typename Pred >
node_pointer | prune (Pred)
void | swap_with_parent (node_pointer, node_pointer)
void | to_linked_list ()
void | value_swap (left_child_next_sibling_heap &)

## Static Protected Member Functions

static void | make_child_of (node_pointer, node_pointer)
static node_pointer | parent (node_pointer)

## Protected Attributes

node_pointer | m_p_root
size_type | m_size

## Detailed Description

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>
class __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >

Base class for a basic heap.

Definition at line 90 of file left_child_next_sibling_heap_.hpp.

## Member Typedef Documentation

## allocator_type

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef _Alloc __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::allocator_type

Definition at line 136 of file left_child_next_sibling_heap_.hpp.

## cmp_fn

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef Cmp_Fn __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::cmp_fn

Definition at line 135 of file left_child_next_sibling_heap_.hpp.

## const_iterator

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef left_child_next_sibling_heap_const_iterator_<node, _Alloc> __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::const_iterator

Definition at line 132 of file left_child_next_sibling_heap_.hpp.

## const_pointer

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef __rebind_v::other::const_pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::const_pointer

Definition at line 122 of file left_child_next_sibling_heap_.hpp.

## const_reference

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef __rebind_v::other::const_reference __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::const_reference

Definition at line 124 of file left_child_next_sibling_heap_.hpp.

## difference_type

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef _Alloc::difference_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::difference_type

Definition at line 118 of file left_child_next_sibling_heap_.hpp.

## iterator

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef const_iterator __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::iterator

Definition at line 134 of file left_child_next_sibling_heap_.hpp.

## node

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef node_allocator::value_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::node

protected

Definition at line 99 of file left_child_next_sibling_heap_.hpp.

## node_allocator

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef _Alloc::template rebind<left_child_next_sibling_heap_node_<Value_Type,Node_Metadata,_Alloc>>::other __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::node_allocator

protected

Definition at line 97 of file left_child_next_sibling_heap_.hpp.

## node_const_pointer

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef node_allocator::const_pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::node_const_pointer

protected

Definition at line 101 of file left_child_next_sibling_heap_.hpp.

## node_metadata

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef Node_Metadata __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::node_metadata

protected

Definition at line 102 of file left_child_next_sibling_heap_.hpp.

## node_pointer

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef node_allocator::pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::node_pointer

protected

Definition at line 100 of file left_child_next_sibling_heap_.hpp.

## node_pointer_pair

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef std::pair< node_pointer, node_pointer> __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::node_pointer_pair

protected

Definition at line 103 of file left_child_next_sibling_heap_.hpp.

## point_const_iterator

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef left_child_next_sibling_heap_node_point_const_iterator_<node, _Alloc> __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::point_const_iterator

Definition at line 127 of file left_child_next_sibling_heap_.hpp.

## point_iterator

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef point_const_iterator __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::point_iterator

Definition at line 129 of file left_child_next_sibling_heap_.hpp.

## pointer

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef __rebind_v::other::pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::pointer

Definition at line 121 of file left_child_next_sibling_heap_.hpp.

## reference

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef __rebind_v::other::reference __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::reference

Definition at line 123 of file left_child_next_sibling_heap_.hpp.

## size_type

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef _Alloc::size_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::size_type

Definition at line 117 of file left_child_next_sibling_heap_.hpp.

## value_type

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

typedef Value_Type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::value_type

Definition at line 119 of file left_child_next_sibling_heap_.hpp.

## Member Data Documentation

## m_p_root

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

node_pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::m_p_root

protected

Definition at line 267 of file left_child_next_sibling_heap_.hpp.

## m_size

template<typename Value_Type , typename Cmp_Fn , typename Node_Metadata , typename _Alloc >

size_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::m_size

protected

Definition at line 268 of file left_child_next_sibling_heap_.hpp.

The documentation for this class was generated from the following file:

- left_child_next_sibling_heap_.hpp